<?php

/***********************************************
*                                              *
* Nagios plugin for checking if there is a     *
* running VM  or more then one HV and if there *
* are unused iptables values                   *
*                                              *
* v0.99                                        *
*                                              *
* ztodorov@neterra.net                         *
************************************************
*/

// check return code of executed program
function check_exec_status($exec_status)
{
    if ($exec_status !== 0) {
        $status = 'UNKNOWN';
        $statusID = 3;
        echo 'ONAPP Ghosts ' . $status . "\n";
        exit($statusID);
    }
}

// array for virtual machines names
$vms = array();
// array for iptables output
$ipt = array();
// array for IP addresses
$ips = array();

// connect to OnApp control panel
mysql_connect('localhost', 'nrpe', 'password');
mysql_select_db("onapp");
$qry = "select ip_address,hypervisor_type from hypervisors where enabled=1";

if ($res = mysql_query($qry)) {
    while ($r = mysql_fetch_object($res)) {
        unset($exec_status);
        if ($r->hypervisor_type === 'kvm')
            exec('ssh root@' . $r->ip_address . ' ps uax|grep /usr/libexec/qemu-kvm|awk \'{print $13}\'|grep .', $vms, $exec_status);
        if ($r->hypervisor_type === 'xen')
            exec('ssh root@' . $r->ip_address . ' ps uax|grep qemu-dm|awk -F "domain-name" \'{print $2}\'|awk \'{print $1}\'|grep .', $vms, $exec_status);
        check_exec_status($exec_status);
        exec('ssh root@' . $r->ip_address . ' iptables-save|grep \'A FORWARD \'|grep -v MARK|awk \'{print $4, $8}\'|sort|uniq', $ipt, $exec_status);
        check_exec_status($exec_status);
    }
}

// test if a VM is alive on more than one HV
reset($vms);
foreach (array_count_values($vms) as $key => $v) {
    
    if ($v !== 1) {
        $status = 'CRITICAL';
        $statusID = 2;
        echo 'ONAPP Ghosts ' . $status . ' - at least one VM (ID:' . $key . ') is running on more than one HV. You must check all HVs.' . "\n";
        exit($statusID);
    }
}
unset($v);

// test if deleted VM is alive - Walking Dead
reset($vms);
foreach ($vms as $v) {
    
    $qry = "select virtual_machines.deleted_at as deleted, hypervisors.label as hv from virtual_machines join hypervisors on virtual_machines.hypervisor_id=hypervisors.id where 
identifier like '$v'";
    
    if ($res = mysql_query($qry)) {
        while ($r = mysql_fetch_object($res)) {
            if (empty($r->hv) or $r->deleted) {
                $status = 'CRITICAL';
                $statusID = 2;
                echo 'ONAPP Ghosts ' . $status . ' - at least one Walking Dead (ID:' . $v . ') is found. It has been configured to work on HV ' . $r->hv . '. You must check all 
HVs.' . "\n";
                exit($statusID);
            }
        }
    }
}
unset($v);

// test for duplicated(wrong) iptables records (IPs)
reset($ipt);

foreach ($ipt as $v) {
    $ip = explode(' ', $v);
    array_push($ips, $ip[0]);
}
unset($v);

foreach (array_count_values($ips) as $key => $v) {
    if ($v !== 1) {
        $status = 'WARNING';
        $statusID = 1;
        echo 'ONAPP Ghosts ' . $status . ' - at least one iptables record for IP ' . $key . ' is found on more than one HV. You must check all HVs.' . "\n";
        exit($statusID);
    }
}
unset($v);

// test for unknown/deleted but active iptables records
reset($ipt);

foreach ($ipt as $v) {
    
    $ids = explode(' ', $v);
    
    $qry = "select virtual_machines.deleted_at as deleted, network_interfaces.identifier as netid from network_interfaces join virtual_machines on 
network_interfaces.virtual_machine_id=virtual_machines.id where network_interfaces.identifier like '$ids[1]'";
    
    if ($res = mysql_query($qry)) {
        if ($r = mysql_fetch_object($res)) {
            if ($r->deleted) {
                $status = 'WARNING';
                $statusID = 1;
                echo 'ONAPP Ghosts ' . $status . ' - at least one iptables record for deleted but active IP/Network interface identifier ' . $v . ' is found on a HV. You must check 
all HVs.' . "\n";
                exit($statusID);
            }
        } else {
            $status = 'WARNING';
            $statusID = 1;
            echo 'ONAPP Ghosts ' . $status . ' - at least one iptables record for unknown but active IP/Network interface identifier ' . $v . ' is found on a HV. You must check all 
HVs.' . "\n";
            exit($statusID);
        }
    }
}
unset($v);

//everything is OK
$status = 'OK';
$statusID = 0;
echo 'ONAPP Ghosts ' . $status ."\n";
exit($statusID);

?>

